# Copyright 2024 Superlinked, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from beartype.typing import Iterator, Sequence, TypeVar

T = TypeVar("T")


def chunk_list(data: Sequence[T], chunk_size: int) -> Iterator[list[T]]:
    return (list(data[i : i + chunk_size]) for i in range(0, len(data), chunk_size))
